#!/usr/bin/python

import smtplib
import os
import sys
from com.sun.star.awt import Rectangle
from com.sun.star.awt import WindowDescriptor
from com.sun.star.awt.WindowClass import MODALTOP
from com.sun.star.awt.VclWindowPeerAttribute import OK, OK_CANCEL, YES_NO, YES_NO_CANCEL, RETRY_CANCEL, DEF_OK, DEF_CANCEL, DEF_RETRY, DEF_YES, DEF_NO
from email.MIMEMultipart import MIMEMultipart
from email.MIMEBase import MIMEBase
from email.MIMEText import MIMEText
from email.Utils import COMMASPACE, formatdate
from email import Encoders
from email.header import Header

def getdataGroupe():
	document = XSCRIPTCONTEXT.getDocument() #connection au document CALC ouvert
        feuilles = document.Sheets
        feuilledata=feuilles.getByName("variable")	
	send_to=[] # on cree une liste vide
	send_CC=[]
	files=[]
	cellule2=feuilledata.getCellByPosition (0,2) # on recupere le nombre d'adherent au lieu de l'unique adherent
        nbAdh=cellule2.Value
	
	print nbAdh
	for a in range(nbAdh):  #on defini la boucle pour recuperer les adresses courriel
		cellule2=feuilledata.getCellByPosition (4,3+a)
		cellsend_to=cellule2.String
		if len(cellsend_to)>0:  # on teste la longueur de l'adresse car elle peut etre vide tout le monde n'a pas forcement une adresse
			send_to.append(cellsend_to) #on rajoute l'adresse dans la liste
		else: 
			pass	 
			
	cellule1=feuilledata.getCellByPosition (0,1)
        send_from  = cellule1.String
	cellule3=feuilledata.getCellByPosition (0,3)
	cellsend_CC=cellule3.String
	send_CC.append(cellsend_CC)
        cellule4=feuilledata.getCellByPosition (0,4)
        subject=unicode(cellule4.String)#,"iso-8859-1")
        cellule5=feuilledata.getCellByPosition (0,5)
        text=unicode(cellule5.String)#,"iso-8859-1")
	cellule6=feuilledata.getCellByPosition (0,6)
        server=cellule6.String
	for b in range(7,12):  #on defini la boucle pour recuperer les chemins des pieces jointes
		cellule7=feuilledata.getCellByPosition (0,b)
		cellfiles=cellule7.String
		if len(cellfiles)>0:  # on teste la longueur de l'adresse car si vide pas de pieces jointes
			files.append(cellfiles) #on rajoute le chemin de la pieces jointes
		else: 
			pass
         
        
        repgp=send_mailOutside(send_from, send_to,send_CC, subject, text, files, server)  #call mailOutside function
	return repgp

def getdataOutside():
    # GET DATA FROM SHEET "adherent"
    send_to=[] # on cree une liste vide
    send_CC=[] # on cree une liste vide
    files=[]
    document = XSCRIPTCONTEXT.getDocument()
    feuilles = document.Sheets
    feuilledata=feuilles.getByName("variable")
    cellule1=feuilledata.getCellByPosition (0,1)
    send_from  = cellule1.String
    cellule2=feuilledata.getCellByPosition (0,2)
    cellSend_to=cellule2.String
    send_to.append(cellSend_to)
    cellule3=feuilledata.getCellByPosition (0,3)
    cellSsend_CC=cellule3.String
    send_CC.append(cellSsend_CC)
    cellule4=feuilledata.getCellByPosition (0,4)
    subject=unicode(cellule4.String)#,"iso-8859-1")
    cellule5=feuilledata.getCellByPosition (0,5)
    text=unicode(cellule5.String)#,"iso-8859-1")
    cellule6=feuilledata.getCellByPosition (0,6)
    server=cellule6.String
    for b in range(7,12):  #on defini la boucle pour recuperer les chemins des pieces jointes
		cellule7=feuilledata.getCellByPosition (0,b)
		cellfiles=cellule7.String
		
		if len(cellfiles)>0:  # on teste la longueur de l'adresse car si vide pas de pieces jointes
			files.append(cellfiles) #on rajoute le chemin de la pieces jointes
			
		else: 
			pass
    
    repadh=send_mailOutside(send_from, send_to,send_CC, subject, text, files, server)  #call mailOutside function
    return repadh
    
    
def send_mailOutside(send_from, send_to,send_CC, subject, text, files, server):
  
  msg = MIMEMultipart()
  msg['From'] = send_from
  msg['To'] = COMMASPACE.join(send_to)
  msg['Cc']=COMMASPACE.join(send_CC)
  msg['Date'] = formatdate(localtime=True)
  msg['Subject'] = Header(subject.encode("iso-8859-1"), "iso-8859-1").encode()
  msg.attach( MIMEText(text.encode("iso-8859-1"), 'plain', "iso-8859-1") )
  for fichier in files:
	part = MIMEBase('application', "octet-stream")
	part.set_payload( open(fichier,"rb").read() )   
	Encoders.encode_base64(part)
	part.add_header('Content-Disposition', 'attachment; filename="%s"' % os.path.basename(fichier))
	msg.attach(part)

  smtp = smtplib.SMTP(server)
  try:
    smtp.sendmail(send_from, send_to, msg.as_string())
    rep="ok"
  except:
    smtp.quit()
    
    coderr = "%s" % sys.exc_info()[1]
    #TestMessageBox(coderr)	
    rep= coderr	
  smtp.close()
  
  return rep







def TestMessageBox(mes):
	doc = XSCRIPTCONTEXT.getDocument()
	parentwin = doc.CurrentController.Frame.ContainerWindow
	
	s = mes
	t = "Test"
	res = MessageBox(parentwin, s, t, "querybox", YES_NO_CANCEL + DEF_NO)
	
	#s = res
	#MessageBox(parentwin, s, t, "infobox")



# Show a message box with the UNO based toolkit
def MessageBox(ParentWin, MsgText, MsgTitle, MsgType="messbox", MsgButtons=OK):
	
	MsgType = MsgType.lower()
	
	#available msg types
	MsgTypes = ("messbox", "infobox", "errorbox", "warningbox", "querybox")
	
	if not ( MsgType in MsgTypes ):
		MsgType = "messbox"
	
	#describe window properties.
	aDescriptor = WindowDescriptor()
	aDescriptor.Type = MODALTOP
	aDescriptor.WindowServiceName = MsgType
	aDescriptor.ParentIndex = -1
	aDescriptor.Parent = ParentWin
	#aDescriptor.Bounds = Rectangle()
	aDescriptor.WindowAttributes = MsgButtons
	
	tk = ParentWin.getToolkit()
	msgbox = tk.createWindow(aDescriptor)
	
	msgbox.setMessageText(MsgText)
	if MsgTitle :
		msgbox.setCaptionText(MsgTitle)
		
	return msgbox.execute()


